﻿// --------------------------------------------------------------------------------------
//
// HochRegalTest1                                                  Ulrich Müller 07.04.11
//                                                                 Aspire C# 2005 Express
// Test Modell Hochregallager
// Turm Home -> 2345
//
// --------------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using FishFaceTX;

namespace HochRegalTest1 {
  public partial class frmMain : Form {
    FishFace tx = new FishFace();

    private void Action() {
      tx.SetMotor(Mot.M1, Dir.Left);
      tx.WaitForInput(Unv.I1);
      tx.SetMotor(Mot.M1, Dir.Off);
      tx.SetMotor(Mot.M3, Dir.Left);
      tx.WaitForInput(Unv.I3);
      tx.SetMotor(Mot.M3, Dir.Off);
      tx.Pause(1234);
      tx.StartMotor(Mot.M1, Dir.Right, 512, 3456);
      tx.WaitForMotor(Mot.M1);
    }

    #region --- Programm-Kontrolle ---
    public frmMain() {
      InitializeComponent();
    }

    private void cmdAction_Click(object sender, EventArgs e) {
      try {
        tx.OpenController(txtCom.Text);
        cmdAction.Enabled = false;
        cmdEnde.Text = "&HALT";
        lblStatus.Text = "--- Bei der Arbeit ---";
        lblHinweis.Text = "--- Ende : HALT-Button oder ESC-Taste ---";

        Action();        // --- Haupt-Routine der Anwendung

      }
      catch (FishFaceException txe) {
        MessageBox.Show(txe.Message, this.Text,
          MessageBoxButtons.OK, MessageBoxIcon.Stop);
      }
      finally {
        tx.CloseController();
        cmdAction.Enabled = true;
        cmdEnde.Text = "&ENDE";
        lblStatus.Text = "--- Auf ein Neues ---";
        lblHinweis.Text = "Nochmal : ACTION, sonst ENDE oder ESC-Taste";
        cmdAction.Focus();
      }
    }

    private void cmdEnde_Click(object sender, EventArgs e) {
      // --- Programmende nur, wenn Action nicht läuft ---
      if (cmdEnde.Text == "&HALT") tx.NotHalt = true; else this.Close();
    }

    private void formClosing(object sender, FormClosingEventArgs e) {
      // --- Wenn Action läuft, wird ein Programmabbruch über (x) unterbunden ------
      if (cmdEnde.Text == "&HALT") e.Cancel = true;
    }
    #endregion
  }
}