﻿// --------------------------------------------------------------------------------------
//
// Hochregal1b                                                     Ulrich Müller 08.04.11
//                                                                 Aspire C# 2005 Express
// ROBO TX Automation Robots : Modell Hochregal1 
// 1:1 Umsetzung des RoboPro Programms mit FishDevices
//
// --------------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using FishFaceTX;

namespace Hochregal1b {
  public partial class frmMain : Form {
    FishControl fc = new FishControl();
    RobMotors ArmTurm;
    LimitedMotor Gabel;
    private void Action() {
      Gabel.MoveLeft();             // --- Referenzfahrt
      ArmTurm.MoveHome();

      ArmTurm.MoveTo(0, 40);        // --- Bereitstellung

      Gabel.MoveRight();            // --- Gabel vor
      ArmTurm.MoveDelta(0, 150);    // --- Gabel heben
      Gabel.MoveLeft();             // --- Gabel zurück

      ArmTurm.MoveTo(3100, 1900);   // --- Platz 1 

      ArmTurm.MoveDelta(0, 150);    // --- Gabel heben
      Gabel.MoveRight();            // --- Gabel vor
      ArmTurm.MoveDelta(0, -150);   // --- Gabel senken
      Gabel.MoveLeft();             // --- Gabel zurück

      ArmTurm.MoveHome();           // --- Referenzfahrt
    }

    #region --- Programm-Kontrolle ---
    public frmMain() {
      InitializeComponent();
      ArmTurm = new RobMotors(fc, Ctr.Main, 
        new RobData(Mot.M1, 6000), new RobData(Mot.M3, 2500));
      Gabel = new LimitedMotor(fc, Ctr.Main, Mot.M2, Unv.I2, Unv.I4);
    }

    private void cmdAction_Click(object sender, EventArgs e) {
      try {
        fc.Connect(txtCom.Text);
        //fc.StartEvents();
        cmdAction.Enabled = false;
        cmdEnde.Text = "&HALT";
        lblStatus.Text = "--- Bei der Arbeit ---";
        lblHinweis.Text = "--- Ende : HALT-Button oder ESC-Taste ---";

        Action();        // --- Haupt-Routine der Anwendung

      }
      catch (FishFaceException txe) {
        MessageBox.Show(txe.Message, this.Text,
          MessageBoxButtons.OK, MessageBoxIcon.Stop);
      }
      finally {
        fc.DisConnect();
        cmdAction.Enabled = true;
        cmdEnde.Text = "&ENDE";
        lblStatus.Text = "--- Auf ein Neues ---";
        lblHinweis.Text = "Nochmal : ACTION, sonst ENDE oder ESC-Taste";
        cmdAction.Focus();
      }
    }

    private void cmdEnde_Click(object sender, EventArgs e) {
      // --- Programmende nur, wenn Action nicht läuft ---
      if (cmdEnde.Text == "&HALT") fc.NotHalt = true; else this.Close();
    }

    private void formClosing(object sender, FormClosingEventArgs e) {
      // --- Wenn Action läuft, wird ein Programmabbruch über (x) unterbunden ------
      if (cmdEnde.Text == "&HALT") e.Cancel = true;
    }
    #endregion
  }
}